



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Lazy evaluation</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Lazy evaluation</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 17:13:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>是一段源码，关于Lazy evaluation的，看了很久才懂，记录一下</p>
<p>一，lazy方法返回的比较复杂，一层一层将其剥开。</p>
<ol><li>wraps(func)跳转到curry(update_wrapper, func, WRAPPER_ASSIGNMENTS, WRAPPER_UPDATES)，最后return一个闭包，通过type(wraps(func))可以看到这是一个&lt;function _curried&gt;。</li>
<li>wraps(func)(__wrapped)则会调用_curried(__wrapped__)，进而调用update(func, __wrapped__ ,WRAPPER_ASSIGNMENTS, WRAPPER_UPDATE)，这里注意WRAP这两个都是dict，所以会被收纳进**kwargs中。</li>
<li>通过update函数会把func的__module__，__name__，__doc__内容复制到&lt;function __wrapper__&gt;中，这样type(wrap(func)(__wrapper__))时，会返回一个&lt;function func&gt;。</li></ol>
<p>这样lazy的返回就解析完了，这时候我们获得了一个__proxy__的构造函数。</p>
<div>
<pre class="prettyprint linenums"> def curry(_curried_func, *args, **kwargs):<br />
     def _curried(*moreargs, **morekwargs):<br />
         return _curried_func(*(args+moreargs), **dict(kwargs, **morekwargs))<br />
     return _curried

 WRAPPER_ASSIGNMENTS = ('__module__', '__name__', '__doc__')<br />
 WRAPPER_UPDATES = ('__dict__',)<br />
 def update_wrapper(wrapper,<br />
                    wrapped,<br />
                    assigned = WRAPPER_ASSIGNMENTS,<br />
                    updated = WRAPPER_UPDATES):<br />
     """Update a wrapper function to look like the wrapped function

        wrapper is the function to be updated<br />
        wrapped is the original function<br />
        assigned is a tuple naming the attributes assigned directly<br />
        from the wrapped function to the wrapper function (defaults to<br />
        functools.WRAPPER_ASSIGNMENTS)<br />
        updated is a tuple naming the attributes off the wrapper that<br />
        are updated with the corresponding attribute from the wrapped<br />
        function (defaults to functools.WRAPPER_UPDATES)<br />
     """<br />
     for attr in assigned:<br />
         try:<br />
             setattr(wrapper, attr, getattr(wrapped, attr))<br />
         except TypeError: # Python 2.3 doesn't allow assigning to __name__.<br />
             pass<br />
     for attr in updated:<br />
         getattr(wrapper, attr).update(getattr(wrapped, attr))<br />
     # Return the wrapper so this can be used as a decorator via curry()<br />
     return wrapper

 def wraps(wrapped,<br />
           assigned = WRAPPER_ASSIGNMENTS,<br />
           updated = WRAPPER_UPDATES):<br />
     """Decorator factory to apply update_wrapper() to a wrapper function

        Returns a decorator that invokes update_wrapper() with the decorated<br />
        function as the wrapper argument and the arguments to wraps() as the<br />
        remaining arguments. Default arguments are as for update_wrapper().<br />
        This is a convenience function to simplify applying curry() to<br />
        update_wrapper().<br />
     """<br />
     return curry(update_wrapper, wrapped=wrapped,<br />
                  assigned=assigned, updated=updated)<br />
 class Promise(object):<br />
     """<br />
     This is just a base class for the proxy class created in<br />
     the closure of the lazy function. It can be used to recognize<br />
     promises in code.<br />
     """<br />
     pass

 def lazy(func, *resultclasses):<br />
     """<br />
     Turns any callable into a lazy evaluated callable. You need to give result<br />
     classes or types -- at least one is needed so that the automatic forcing of<br />
     the lazy evaluation code is triggered. Results are not memoized; the<br />
     function is evaluated on every access.<br />
     """<br />
     class __proxy__(Promise):<br />
         """<br />
         Encapsulate a function call and act as a proxy for methods that are<br />
         called on the result of that function. The function is not evaluated<br />
         until one of the methods on the result is called.<br />
         """<br />
         __dispatch = None

         def __init__(self, args, kw):<br />
             self.__func = func<br />
             self.__args = args<br />
             self.__kw = kw<br />
             if self.__dispatch is None:<br />
                 self.__prepare_class__()

         def __prepare_class__(cls):<br />
             cls.__dispatch = {}<br />
             for resultclass in resultclasses:<br />
                 cls.__dispatch[resultclass] = {}<br />
                 for (k, v) in resultclass.__dict__.items():<br />
                     if hasattr(cls, k):<br />
                         continue<br />
                     setattr(cls, k, cls.__promise__(resultclass, k, v))<br />
             cls._delegate_str = str in resultclasses<br />
             cls._delegate_unicode = unicode in resultclasses<br />
             assert not (cls._delegate_str and cls._delegate_unicode), "Cannot call lazy() with both str and unicode return types."<br />
             if cls._delegate_unicode:<br />
                 cls.__unicode__ = cls.__unicode_cast<br />
             elif cls._delegate_str:<br />
                 cls.__str__ = cls.__str_cast<br />
         __prepare_class__ = classmethod(__prepare_class__)

         def __promise__(cls, klass, funcname, func):<br />
             # Builds a wrapper around some magic method and registers that magic<br />
             # method for the given type and method name.<br />
             def __wrapper__(self, *args, **kw):<br />
                 # Automatically triggers the evaluation of a lazy value and<br />
                 # applies the given magic method of the result type.<br />
                 res = self.__func(*self.__args, **self.__kw)<br />
                 for t in type(res).mro():<br />
                     if t in self.__dispatch:<br />
                         return self.__dispatch[t][funcname](res, *args, **kw)<br />
                 raise TypeError("Lazy object returned unexpected type.")

             if klass not in cls.__dispatch:<br />
                 cls.__dispatch[klass] = {}<br />
             cls.__dispatch[klass][funcname] = func<br />
             return __wrapper__<br />
         __promise__ = classmethod(__promise__)

         def __unicode_cast(self):<br />
             return self.__func(*self.__args, **self.__kw)

         def __str_cast(self):<br />
             return str(self.__func(*self.__args, **self.__kw))

         def __cmp__(self, rhs):<br />
             if self._delegate_str:<br />
                 s = str(self.__func(*self.__args, **self.__kw))<br />
             elif self._delegate_unicode:<br />
                 s = unicode(self.__func(*self.__args, **self.__kw))<br />
             else:<br />
                 s = self.__func(*self.__args, **self.__kw)<br />
             if isinstance(rhs, Promise):<br />
                 return -cmp(rhs, s)<br />
             else:<br />
                 return cmp(s, rhs)

         def __mod__(self, rhs):<br />
             if self._delegate_str:<br />
                 return str(self) % rhs<br />
             elif self._delegate_unicode:<br />
                 return unicode(self) % rhs<br />
             else:<br />
                 raise AssertionError('__mod__ not supported for non-string types')

         def __deepcopy__(self, memo):<br />
             # Instances of this class are effectively immutable. It's just a<br />
             # collection of functions. So we don't need to do anything<br />
             # complicated for copying.<br />
             memo[id(self)] = self<br />
             return self

     def __wrapper__(*args, **kw):<br />
         # Creates the proxy object, instead of the actual value.<br />
         return __proxy__(args, kw)

     return wraps(func)(__wrapper__)</pre>
</div>
<p>二，我们现在学着怎么使用lazy。</p>
<ol><li>这里我们新建了两个类，分别为A、B，其中B是A的子类。</li>
<li>当调用x = lazy(func, A, B)(1, 2)的时候，会返回一个__proxy__对象，这里注意，因为类的定义是在lazy方法中，所以__func为func。</li>
<li>这中间会调用__prepare_class__方法，这是一个类方法。他会从resultclasses（这里是A，B）中逐个选择，它维护一个类字典cls.__dispatch，对其中每一个类都把类的__dict__中不包括__main__、__name__、__doc__的属性都经过__promiss__闭包将__wrap__赋给__proxy__类。</li>
<li>在__wrap__执行之前，会在cls.__dispatch中添加一个名为funcname的属性为func。而当调用__wrap__的时候，则会使用func计算初始的*args和**kwargs，解析返回对象的类型列表。</li></ol>
<p>这里要注意一点，任何一个类的__dict__是不会自动包括它父类的属性和方法的，所以最后结果，x.func_a()是会报错的。这应该是这段代码的一个不足或者BUG吧。</p>
<div>
<pre class="prettyprint linenums"> def func(a, b):<br />
     print 'func'<br />
     return B()

 class A(object):<br />
     """docstring for A"""<br />
     def __init__(self):<br />
         super(A, self).__init__()<br />
     def func_a(self):<br />
         print 'in func_a'

 class B(object):<br />
     """docstring for B"""<br />
     def __init__(self):<br />
         super(B, self).__init__()<br />
     def func_b(self):<br />
         print 'in func_b'

 print B.mro()<br />
 x = lazy(func, A, B)(1, 2)<br />
 print x.func_a(), x.func_b()</pre>
</div>
<div>
<pre class="prettyprint linenums"> #[&lt;class '__main__.B'&gt;, &lt;class '__main__.A'&gt;, &lt;type 'object'&gt;]<br />
 #func<br />
 #in func_b<br />
 #None</pre>
</div>
<p>三，怎样实现lazy&nbsp;evaluation？</p>
<p>　　将上面的代码改一下便可以实现lazy evaluation。</p>
<div>
<pre class="prettyprint linenums"> def func(num1, num2):<br />
     return B(num1, num2)

 class A(object):<br />
     """docstring for A"""<br />
     def __init__(self):<br />
         super(A, self).__init__()<br />
     def func_a(self):<br />
         pass

 class B(A):<br />
     """docstring for B"""<br />
     def __init__(self, num1, num2):<br />
         super(B, self).__init__()<br />
         self.num1 = num1<br />
         self.num2 = num2

     def func_b(self, num1, num2):<br />
         print num1 + num2

 a = 1<br />
 b = 2<br />
 c = 3<br />
 x = lazy(func, A, B)(a, b)<br />
 a = b<br />
 b = c<br />
 print a, b, c<br />
 x.func_b(a, b)

 #2 3 3<br />
 #</pre>
</div>
<p>参考：<a href="http://blog.csdn.net/g9yuayon/article/details/759778" rel="external nofollow noreferrer">http://blog.csdn.net/g9yuayon/article/details/759778</a></p>
<p><a href="http://blog.donews.com/superisaac/archive/2006/03/16/771387.aspx" rel="external nofollow noreferrer">http://blog.donews.com/superisaac/archive/2006/03/16/771387.aspx</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390vnl48.html">MYSQL的大数据量情况下的分页查询优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvd2jjq.html">avalonjs</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8km2lr9.html">linux git安装及配置（包括更新）</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rm1348.html">如何更改IP地址的映射名字</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93zlzwq.html">centos 7&period;0 下触发器乱码的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1mz3m9.html">iTween基础之Color&lpar;变换颜色&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xj7nn9.html">WCF分布式开发步步为赢&lpar;9&rpar;&colon;WCF服务实例激活类型编程与开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1lkvr9.html">Uniqueidentifier数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jdy2l8.html">js实现无限级树形导航列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz0k548.html">有关信息ACM&sol;ICPC竞争环境GCC&sol;G&plus;&plus;叠插件研究记录的扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpm7359.html">wamp开机自动启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjm2kk8.html">JS响应数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me5zzpq.html">phpmyadmin登陆错误：The requested URL &sol;phpmyadmin was not found on this serve</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj23gy8.html">python入门篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j76yo8.html">Oracle数据泵远程导入数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kg7k09.html">archlinux中安装Oracle12c的过程中遇到的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wvdlzq.html">BZOJ3536 &colon; &lbrack;Usaco2014 Open&rsqb;Cow Optics</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1lo6w9.html">Shiro授权管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwvpy78.html">server下apache2&period;4&period;&ast;虚拟主机配置Forbidden  You don&amp;&num;39&semi;t have permission to access &sol; on this server&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdxp109.html">自学Linux Shell19&period;1-gawk程序基础特性</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qden1xx9.html">深入浅出SlidingMenu</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okzrkp9.html">求1&plus;2&plus;3&plus;&period;&period;&period;&plus;n的值，要求不能使用乘除法，for、while、if、else、switch、case、等关键字及条件判断语句&lpar;JAVA&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydm3e2q.html">对WEB标准以及W3C的理解与认识 - 提高网页加载速度</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj0rzy9.html">The port Command</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnp7nj8.html">windows----composer、laravel安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydmzgxq.html">python 的内建函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd13zy8.html">OpenLayers 3加载本地Google切片地图</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1nn6e9.html">SQL Server 阻塞排除的 2 方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vzozm8.html">interbase C&plus;&plus;Builder 简单例子</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm2nol9.html">Windows Azure 的开源 DNA</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
